#!/usr/bin/perl

#no warnings;
use utf8;
use SOAP::Lite;
use Encode;
use XML::Simple;
use MIME::Base64;
use LWP;



if($ENV{'SHELL'}){
    if($ENV{'SHELL'} =~ /(bash|console)/i){
        $ANSI = 1;
        use Term::ANSIColor;
    }
}

$DOWARN = 1;
BEGIN { $SIG{'__WARN__'} = sub { warn $_[0] if $DOWARN } }


#defaults
$operation=4;
$filename='';
$user='';
$realm='';
$pwd='';
$filename='';
$def_wsdl = 'file:/var/lib/aosi/www/aosi.wsdl';

#boje
$input_c = 'bold green';
$info_c = 'bold red';
$default_c = 'bold yellow';
$err_c = 'bold red';



$out = '';

$LWP_ver=$LWP::VERSION;
$soap_ver = $SOAP::Lite::VERSION;
safe_print("LWP version: $LWP_ver\n", $info_c);
safe_print("SOAP::Lite version: $soap_ver\n", $info_c);

$user = getstg('uid', $user);

system("stty -echo");
$pwd = getstg('zaporka', $pwd);
system("stty echo");

$pwd = encode_base64($pwd);
chomp($pwd);
print "\n";
$realm = getstg("domena", $realm);
$wsdl = getstg('wsdl', $def_wsdl);

my @tmp_base = split(/\./, $realm);
my @tmp_uid = split(/@/,$user);

$user=$tmp_uid[0];
$realm=$tmp_base[0];

$base_dn = 'dc=' . $realm . ',dc=hr';

$filename= getstg("staza do datoteke s podacima",$filename);
do {
	print "\n
	=========================
	Odaberite vrstu datoteke iz koje zelite uvesti OIB:
	 (1) datoteka s podacima uid;OIB
	 (2) datoteka s podacima JMBG;OIB
	 (3) datoteka s podacima ime;prezime;OIB
	 (4) izlaz
	=========================
	";
	$operation = getstg('', $operation);
} until ( $operation =~ /^([1-4])$/);

if ($operation!=1 && $operation!=2 && $operation!=3) {
	exit;
}

$s = SOAP::Lite->service($wsdl)->on_fault(
    sub {
        my ($soap, $res) = @_;
        $out = ref $res ? $res->faultstring : $soap->transport->status;
        print "**************************************************************************\n";
        print "\aSOAP error: ", $out;
        print "**************************************************************************\n";

        #die ref $res ? $res->faultstring : $soap->transport->status,"\n";
    }
);
$s->soapversion('1.1');

if ($soap_ver < 0.62) {
	$sd_user   = SOAP::Data->name('user')->type('string')->value($user);
	$sd_pwd    = SOAP::Data->name('password')->type('string')->value($pwd);
	$sd_base   = SOAP::Data->name('base')->type('string')->value($base_dn);
	$sd_attrib = SOAP::Data->name('attribute')->type('string')->value('uid');
} else {
	$sd_user   = $user;
	$sd_pwd    = $pwd;
	$sd_base   = $base_dn;
	$sd_attrib = 'uid';
}

open FILE, $filename or die $!;
@data=();
$l=1;
safe_print("\n****Parsiranje ulazne datoteke*****\n\n", $default_c);

while (<FILE>) {
	chomp;
	my @d=split(/;/);
	my @update=();
	my $ok=0;
	
	if($operation==1 || $operation==2){
		$update[1]=$d[1];
	} else {
		$update[1]=$d[2];
	}
	if(valid_oib($update[1])){
		if($operation==1){
			$update[0]='uid=' . $d[0] . ",dc=$realm,dc=hr";
			$ok=1;
		} else {
			my $filter;
			my $uvjet;
			if($operation==2){
				$filter='(hrEduPersonUniqueNumber=JMBG: ' . $d[0] . ')';
				$uvjet='JMBG=' . $d[0];
			} else {
				$filter=utfize('(&(givenName=' . $d[0] . ')(sn=' . $d[1] . '))');
				#$filter='(&(givenName=' . $d[0] . ')(sn=' . $d[1] . '))';
				$uvjet=utf_to_iso('ime=' . $d[0] . ' i prezime=' . $d[1]);
			}
			if ($soap_ver < 0.62) {
				$sd_filter = SOAP::Data->name('filter')->type('string')->value($filter);
		    } else {
		    	$sd_filter = $filter;
		    }
		  	print "linija $l:";
		  	
		  	$DOWARN = 0;
			my ($code, $error, $result) = $s->ldapSearch($sd_user, $sd_pwd, $sd_base, $sd_filter, $sd_attrib);
			$DOWARN = 1;
			
			if($code==0){
				my @dn=process_search_result($result);
				if(scalar(@dn)==1){
					$update[0]=$dn[0];
					$update[0] =~ s/\s+//g;
					$ok=1;
					print " OK dn:" . $dn[0] . "\n";
				} elsif(scalar(@dn)>1){
					safe_print(" greska: vise korisnika zadovoljava $uvjet\n", $err_c);
				} else {
					safe_print(" greska: nijedan korisnik ne zadovoljava $uvjet\n", $err_c);
				}
			} else {
				#neka greska!!
				safe_print("greska: \n", $err_c);
				safe_print("kod:" . nvl($code) . "\n", $err_c);
				safe_print("opis:" . nvl($error) . "\n", $err_c);
				#printf("%25s: %s\n", 'result', nvl($result), $err_c);
			}
		}
		if($ok==1){
			push @data,\@update;
		}
	} else {
		print "linija $l:";
		safe_print(" greska: nije ispravan OIB:" . $update[1] . "\n", $err_c);
	}
	$l++;
}
my $ver;
my ($code, $error, $result) = $s->ldapOrgInfo($sd_user, $sd_pwd, $sd_base);
if($code==0){
	$ver=process_org_result($result);
} else {
	safe_print("Greska!\n", $err_c);
	safe_print("Kod greske: " . nvl($code) . "\n", $err_c);
	safe_print("Opis greske: " . nvl($error) . "\n", $err_c);
	print "Detalji:\n$result\n";
}

if(scalar(@data)>0){
	safe_print("\n****Dodavanje OIB-a pronadjenim korisnicima*****\n\n", $default_c);
	my $xml_update='<ldap>';
	foreach my $d (@data){
		if($ver gt '3.0.0'){
			$xml_update.='<entry dn="' . $d->[0] . '"><attribute ldapname="hrEduPersonOIB"><value>' . $d->[1] . '</value></attribute></entry>';
		} else {
			$xml_update.='<entry dn="' . $d->[0] . '"><attribute ldapname="hrEduPersonUniqueNumber"><value>OIB: ' . $d->[1] . '</value></attribute></entry>';
		}
	}
	$xml_update.='</ldap>';
	#print "\n\n\n***************************************************\n$xml_update\n***************************************************\n\n\n";
	if ($soap_ver < 0.62) {
		$sd_xml  = SOAP::Data->name('attribs')->type('string')->value($xml_update);
	} else {
		$sd_xml  = $xml_update;
	}
	if($ver gt '3.0.0'){
		($code, $error, $result) = $s->ldapModifyAttribute($sd_user, $sd_pwd, $sd_base, $sd_xml);
	} else {
		($code, $error, $result) = $s->ldapAddAttribute($sd_user, $sd_pwd, $sd_base, $sd_xml);
	}
	if($code==0){
		print "Dodavanje OIB-a uspjelo za korisnike:\n";
		my @res=process_search_result($result);
		foreach my $r (@res){
			print "$r\n";
		}
	} else {
		safe_print("Prilikom dodavanja OIB-a doslo je do greske!\n", $err_c);
		safe_print("Kod greske: " . nvl($code) . "\n", $err_c);
		safe_print("Opis greske: " . nvl($error) . "\n", $err_c);
		print "Detalji:\n\n";
		my $res_ref=process_add_result($result);
		my @res = @$res_ref;
		foreach my $r (@res){
			print $r->[0] . ":";
			if($r->[1]==0){
				print " OIB dodan.";
			} else {
				safe_print(" greska: " . $r->[2], $err_c);
			}
			if($r->[3]!=0){
				safe_print(", greska prije plugina: " . $r->[4], $err_c);
			}
			if($r->[5]!=0){
				safe_print(", greska poslije plugina: " . $r->[6], $err_c);
			}
			print "\n";
		}
	}
}

sub valid_oib {
	return 0 unless $_[0] =~ /^\d{11}$/;
	my @chars = split(//, $_[0]);
	my $P = 10;
	my $S;
	for my $a (@chars) {
		$S = $P%11 + $a;
		$P = ($S%10 || 10) * 2;
	}
	return $S%10 == 1;
}
sub valid_jmbg {
	return 0 unless $_[0] =~ /^\d{13}$/;
	my @c = split(//, $_[0]);
	my $S=0;
	for (my $i=0;$i<6;$i++){
		$S+= (7-$i)*($c[$i]+$c[6+$i]);
	}
	return 11-($S%11) == $c[12];
}

sub utfize {
    my ($value) = @_;
    utf8::decode($value);
    if($LWP_ver<'5.810'){
    	return $value;
    } else {
    	return encode("utf-8",$value);
    }
}

sub utf_to_iso {
    my ($value) = @_;
   # encode("iso-8859-1",$value);
    return encode("iso-8859-1",$value);
}

sub nvl {
    my ($in, $val) = @_;
    my ($out);

    $out = $in;
    $val = defined $val ? $val : '';
    $out = defined $out ? $out : $val;
    return $out;
}

sub process_add_result {
    my ($xml_in) = @_;
    my ($xml, $out, $ent, $attrs, $status, $bstatus, $astatus);
    my ($attr, $key, $val, $vals, $name, $code);

    my @out;

    if($xml_in){
        $xml = XMLin($xml_in, ForceArray => [ 'entry', 'attribute', 'value', 'status', 'before_plugin_status', 'after_plugin_status' ], KeyAttr => []);

        foreach $ent (@{ $xml->{'entry'} }) {
        	my @e;
        	
        	my $status_code=0;
        	my $before_code=0;
        	my $after_code=0;
        	my ($dn,$status_mess,$before_mess,$after_mess);
            $dn = $ent->{'dn'};
            $status  = $ent->{'status'};
            $bstatus = $ent->{'before_plugin_status'};
            $astatus = $ent->{'after_plugin_status'};
            if (ref($bstatus) eq 'ARRAY') {
                foreach $key (@$bstatus) {
                    $name = $key->{'name'};
                    $code =$key->{'code'};
                    $val  = $key->{'content'};
                    if($code!=0){
                    	$before_code=1;
                    }
                    $before_mess.="plugin: $name, kod: $code, " . nvl($val, '-');
                }
            }
            if (ref($status) eq 'ARRAY') {
                foreach $key (@$status) {
                    $code = $key->{'code'};
                    $val  = $key->{'content'};
                    if($code!=0){
                    	$status_code=1;
                    }
                	$status_mess.="kod: $code, " . nvl($val, '-');
                }
            }
            if (ref($astatus) eq 'ARRAY') {
                foreach $key (@$astatus) {
                    $name = $key->{'name'};
                    $code = $key->{'code'};
                    $val  = $key->{'content'};
                   	if($code!=0){
                    	$after_code=1;
                    }
                    $after_mess.="plugin: $name, kod: $code, " . nvl($val, '-');
                }
            }
            @e=($dn,$status_code,$status_mess,$before_code,$before_mess,$after_code,$after_mess);
            push @out,\@e;
        }
    }
    return \@out;
}

sub process_search_result {
    my ($xml_in) = @_;
    my ($xml, @out, $ent);

    $out = "\n";

    if($xml_in){
        $xml = XMLin($xml_in, ForceArray => [ 'entry', 'attribute', 'value', 'status', 'before_plugin_status', 'after_plugin_status' ], KeyAttr => []);
        foreach $ent (@{ $xml->{'entry'} }) {
            my $dn = $ent->{'dn'};
            push @out,$dn;
        }
    }
    return @out;
}
sub process_org_result {
    my ($xml_in) = @_;
    my ($xml, $ver);

    if($xml_in){
        $xml = XMLin($xml_in, ForceArray => ['entry', 'attribute', 'value', 'status', 'before_plugin_status', 'after_plugin_status'], KeyAttr => [], KeepRoot => 1);
        $ver = $xml->{'ldap'}->{'version'}; 
    }
    return $ver;
}
sub dump_to_file {
    my ($stg) = @_;
    open(LOG, ">>ac.log") or die "cannot log to ac.log ($!)\n";
    print LOG $stg;
    close(LOG);
}

sub getstg {
    my($label, $default) = @_;
    my($out, $ans, $spc);

    $spc = $label ne '' ? ' ' : '';

    print $label.$spc."[";
    if($ANSI){
        $Term::ANSIColor::AUTORESET = 1;
        safe_print("$default", $default_c);
    }
    else {
        print "$default";
    }
    print "]: ";
    if($ANSI){
        print color $input_c;
    }
    $out = $default;
    chomp($ans = <STDIN>);
    if ($ans ne '') {
        $out = $ans;
    }
    if($ANSI){
        print color 'reset';
    }

    return $out;
}

sub safe_print {
    my($stg, $color) = @_;

    if($ANSI){
        print colored ($stg, $color);
    }
    else {
        print $stg;
    }
}
